package View;

import javax.swing.JFrame;

import Model.LayeredGraphNode;

public class MainView {

	JFrame frame;
	
	public MainView( LayeredGraphNode graph )
	{
		frame = new JFrame();
        frame.setSize( (int)graph.getWidth() + 200, (int)graph.getHeight() + 200 );
		frame.setLocation( 100, 100 );
		frame.setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
		frame.setVisible( true );
		
		NodeView view = createNodeView( graph );
		graph.setX( 40 );
		graph.setY( 40 );
		frame.add( view );
		
		frame.repaint();
	}
	
	private NodeView createNodeView( LayeredGraphNode gNode )
	{
		NodeView graphView = new NodeView( gNode );
		for( LayeredGraphNode n : gNode.getContainedNodes() )
			graphView.add( createNodeView( n ) );
		return graphView;
	}
}
