package View;

import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;

import javax.swing.*;

import Model.LayeredGraphNode;

public class NodeView extends JPanel {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private LayeredGraphNode model;
	
	public NodeView( LayeredGraphNode model ) {
		this.model = model;
	}
	
	@Override
	public int getX()
	{
	    return (int)model.getX();
	}
    
    @Override
    public int getY()
    {
        return (int)model.getY();
    }
    
    @Override
    public int getWidth()
    {
        return (int)model.getWidth();
    }
    
    @Override
    public int getHeight()
    {
        return (int)model.getHeight();
    }
    
    
    @Override
    public void paint( Graphics g )
    {
        paintComponent( g );
        for( Component c : getComponents() )
            c.paint( g.create( 
                    c.getX() + 10, 
                    c.getY() + 10, 
                    Math.min( getWidth() - 10, c.getWidth() + c.getX() + 10 ), 
                    Math.min( getHeight() - 10, c.getHeight() + c.getY() + 10 ) ) );
    }

	@Override
	public void paintComponent( Graphics g )
	{
	    super.paintComponent(g);
		System.out.print( "Drawing: Node " + model.getName() + " Position (" + model.getX() + "," + model.getY() + ") Size (" + model.getWidth() + "," + model.getHeight() + ")\n" );
		g.setColor( Color.RED );
		g.drawRect( 0, 0, getWidth()-1, getHeight()-1 );
	}
}
